package Security::pkgchk;

use Exporter;
use strict;
use warnings;

our @ISA = qw(Exporter);
our @EXPORT = qw( &init() &check() &print() );

our (%perms);

sub init {
	print ( STDERR "In Security::pkgchk::init()\n") if ( $main::opts{'d'} );

	$main::pkgchk = '/usr/sbin/pkgchk' if ( -f '/usr/sbin/pkgchk' );
}

sub check {
	my ($dir);
	print ( STDERR "In Security::pkgchk::check()\n") if ( $main::opts{'d'} );

	print ( STDERR "\tRunning cmd $main::pkgchk -n -q\n") if ( $main::opts{'d'} );
	if (open (FP, "$main::pkgchk -n -q 2>&1 |")) {
		while (<FP>) {
			chop;
			if ( $_ =~ /ERROR: /o ) {
				$dir = $_;
				$dir =~ s/^ERROR: //go;
				$perms{$dir} = 1;
			} elsif ( length ($dir) > 1 ) {
				s/permissions /mode /;
				s/group name /group /;
				s/\> expected \</:/;
				s/ actual//;
				s/\</(/;
				s/\>/)/;
				if ( exists $perms{$dir} ) {
					$perms{$dir}=($perms{$dir} eq '1')
						? $_ : $perms{$dir} . $_;
					$perms{$dir} =~ s/  / /g;
				}
			} else {
				print ( STDERR "\tDo not know what to do with $_\n\tdir = $dir\n") if ( $main::opts{'d'} );
			}
		}
		close FP;
	} else {
		print ( STDERR "ERROR: Running cmd $main::pkgchk -n -q\n") if ( $main::opts{'d'} );
	}
}

sub print {
	print ( STDERR  "In Security::pkgchk::print()\n") if ( $main::opts{'d'} );

	&main::print_data ("\n\nchecking pkgchk command output:\n", %perms);
}

1;
